/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2014, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"net_germ_neigh_.h"

void
net_germ_neigh (struct IN In, struct GERMSET *pGermSet)
{
  if (!strcmp (In.ttype, "standard"))
  {
    (*pGermSet).nSize = ut_alloc_2d (3, 2);
    ut_array_2d_memcpy ((*pGermSet).nSize, 3, 2, (*pGermSet).Size);
    (*pGermSet).nVol = 0;
    (*pGermSet).nN = 0;
    (*pGermSet).nGermCoo = NULL;

    (*pGermSet).nGermRandId = NULL;
  }
  else if (!strcmp (In.ttype, "periodic"))
  {
    GermSetSize (pGermSet);
    GermSetGermsPer (pGermSet);
  }
  else if (!strcmp (In.ttype, "subdomain"))
  {
    if ((*pGermSet).N != 0)
    {
      GermSetSize (pGermSet);
      GermSetGermsSD (pGermSet);
    }
    else
      GermSet4EmpD (pGermSet);
  }
  else
    ut_error_reportbug ();

  return;
}

void
net_n1d_morpho_n (int n1d, char *morpho, int *pn)
{
  if (strcmp (morpho, "cube") == 0)
    (*pn) = n1d * n1d * n1d;
  else if (strcmp (morpho, "tocta") == 0)
    (*pn) = (n1d - 1) * (n1d - 1) * (n1d - 1) + n1d * n1d * n1d;

  return;
}
