/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2014, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"net_tesr_vor_.h"

void
net_tesr_vor3 (struct TESS Domain, struct GERMSET GSet, struct TESR *pTesr)
{
  int i, j, k, l;
  double *coo = ut_alloc_1d (3);
  int *pos = ut_alloc_1d_int (3);
  double *GermDist = ut_alloc_1d (GSet.N + GSet.nN + 1);

  (*pTesr).Dim = GSet.Dim;

  for (k = 1; k <= (*pTesr).size[2]; k++)
    for (j = 1; j <= (*pTesr).size[1]; j++)
      for (i = 1; i <= (*pTesr).size[0]; i++)
      {
	ut_array_1d_int_set_3 (pos, i, j, k);
	neut_tesr_coo (*pTesr, pos, coo);

	if ((*pTesr).Dim == 1 || neut_tess_point_incell (Domain, coo, 1))
	{
	  for (l = 1; l <= GSet.N; l++)
	    GermDist[l] = ut_space_dist (coo, GSet.GermCoo[l]);

	  for (l = 1; l <= GSet.nN; l++)
	    GermDist[GSet.N + l] = ut_space_dist (coo, GSet.nGermCoo[l]);

	  (*pTesr).VoxCell[i][j][k] =
	    1 + ut_array_1d_min_index (GermDist + 1, GSet.N + GSet.nN);
	}
      }

  (*pTesr).GermCoo = ut_alloc_2d ((*pTesr).CellQty + 1, 3);
  ut_array_2d_memcpy ((*pTesr).GermCoo + 1, (*pTesr).CellQty, 3,
		      GSet.GermCoo + 1);
  (*pTesr).GermWeight = ut_alloc_1d ((*pTesr).CellQty + 1);
  ut_array_1d_memcpy ((*pTesr).GermWeight + 1, (*pTesr).CellQty,
		      GSet.GermWeight + 1);

  ut_free_1d (GermDist);
  ut_free_1d (coo);
  ut_free_1d_int (pos);

  return;
}
